package com.yc.ship.module.miniapplet.service.adsense;


import com.yc.ship.framework.common.pojo.PageResult;
import com.yc.ship.module.miniapplet.controller.admin.adsense.vo.AdsensePageReqVO;
import com.yc.ship.module.miniapplet.controller.admin.adsense.vo.AdsenseSaveReqVO;
import com.yc.ship.module.miniapplet.controller.app.advert.vo.AppAdvertReqVO;
import com.yc.ship.module.miniapplet.dal.dataobject.adsense.AdsenseDO;

import javax.validation.Valid;
import java.util.Collection;
import java.util.List;

/**
 * 广告位管理 Service 接口
 *
 * @author 管理员
 */
public interface AdsenseService {

    /**
     * 创建广告位管理
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createAdsense(@Valid AdsenseSaveReqVO createReqVO);

    /**
     * 更新广告位管理
     *
     * @param updateReqVO 更新信息
     */
    void updateAdsense(@Valid AdsenseSaveReqVO updateReqVO);

    /**
     * 删除广告位管理
     *
     * @param id 编号
     */
    void deleteAdsense(Long id);

    /**
     * 获得广告位管理
     *
     * @param id 编号
     * @return 广告位管理
     */
    AdsenseDO getAdsense(Long id);

    /**
     * 获得广告位管理分页
     *
     * @param pageReqVO 分页查询
     * @return 广告位管理分页
     */
    PageResult<AdsenseDO> getAdsensePage(AdsensePageReqVO pageReqVO);

    List<AdsenseDO> getAdsenseListByStatus(Integer status);

    List<AdsenseDO> getAdsenseList(Collection<Long> ids);

    List<AdsenseDO> getAdsenseList(AppAdvertReqVO reqVO);

    /**
     * 获得广告位
     *
     * @param code 广告位编码
     * @return 广告位管理
     */
    AdsenseDO getAdsenseByCode(String code);
}
